using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services.Protocols;
using System.IO;

namespace MarcusWS_Sample
{
    class Utils
    {
        //create DW specific SOAP header
        public static SoapHeader GetMobileManagerHeader(string token)
        {
            MarcusWS_Sample.MobileManagerV1.DWHeader header = new MarcusWS_Sample.MobileManagerV1.DWHeader();
            MarcusWS_Sample.MobileManagerV1.SenderInfo si = new MarcusWS_Sample.MobileManagerV1.SenderInfo();
            si.ApplicationID = "SampleClient"; //user supplied value for tracking

            MarcusWS_Sample.MobileManagerV1.Credentials cred = new MarcusWS_Sample.MobileManagerV1.Credentials();
            cred.AuthToken = token;
            si.Credentials = cred;
            header.SenderInfo = si;

            return header;
        }

        //create DW specific SOAP header  -- same as GetMobileManagerHeader
        public static SoapHeader GetTrackManagerHeader(string token)
        {
            MarcusWS_Sample.TrackManagerV1.DWHeader header = new MarcusWS_Sample.TrackManagerV1.DWHeader();
            MarcusWS_Sample.TrackManagerV1.SenderInfo si = new MarcusWS_Sample.TrackManagerV1.SenderInfo();
            si.ApplicationID = "SampleClient2"; //user supplied value for tracking

            MarcusWS_Sample.TrackManagerV1.Credentials cred = new MarcusWS_Sample.TrackManagerV1.Credentials();
            cred.AuthToken = token;
            si.Credentials = cred;
            header.SenderInfo = si;

            return header;
        }

        //simple means to get DW supplied error from SOAP exception
        public static string GetErrorMessage(Exception s)
        {
            if (s.GetType().Equals(typeof(SoapException)))
            {
                SoapException se = (SoapException)s;
                if (se.Detail.FirstChild != null && se.Detail.FirstChild.FirstChild != null)
                {
                    String code = se.Detail.FirstChild.FirstChild.InnerText;
                    String message = se.Detail.FirstChild.FirstChild.NextSibling.InnerText;
                    return code + ", " + message;
                }
            }
            return s.Message;
        }

        //just write to a file for demo purposes
        public static void WriteTracksToFile(String filename, String text)
        {
            TextWriter tw = new StreamWriter(filename);
         //   text = text.Replace("\n", "");
            tw.WriteLine(text);
            tw.Close();
        }
    }
}
