using System;
using System.Collections.Generic;
using System.Text;
using MarcusWS_Sample.AuthenticationManagerV1;
using System.Web.Services.Protocols;
using System.Windows.Forms;
using MarcusWS_Sample.MobileManagerV1;
using MarcusWS_Sample.TrackManagerV1;

namespace MarcusWS_Sample
{
    public class WebServices
    {
        public static string GetToken(string username, string password)
        {
            //create service object  -- no header required for authenticaiton methods
            AuthenticationManagerV1Port service = new AuthenticationManagerV1Port();

            //create request object
            AuthenticationManagerV1.getAuthenticationTokenRequest req = new AuthenticationManagerV1.getAuthenticationTokenRequest();
            
            //set request parameters
            req.username = username;
            req.password = password;

            //call service
            getAuthenticationTokenResponse response = service.getAuthenticationToken(req);
            if (response != null)
            {
                return response.AuthToken;
            }
            return null;
        }

        public static MobileWithId[] GetMobiles(SoapHeader header)
        {
            MobileManagerV1Port service = new MobileManagerV1Port();
            MobileManagerV1.FindAllMobilesRequest req = new MobileManagerV1.FindAllMobilesRequest();
            service.DWHeaderValue = (MarcusWS_Sample.MobileManagerV1.DWHeader)header;
            FindAllMobilesResponse resp = service.FindAllMobiles(req);
            MarcusWS_Sample.MobileManagerV1.MobileWithId[] mobiles = resp.Mobiles.Mobile;
            return mobiles;
        }

        public static MarcusWS_Sample.TrackManagerV1.Track[] GetTracksForMobile(SoapHeader header, String name, DateTime since)
        {
            TrackManagerV1Port service = new TrackManagerV1Port();
            TrackManagerV1.GetTracksByMobileSinceRequest req = new TrackManagerV1.GetTracksByMobileSinceRequest();
            service.DWHeaderValue = (MarcusWS_Sample.TrackManagerV1.DWHeader) header;
            req.Name = name;
            req.Since = since;
            req.Since = DateTime.SpecifyKind(req.Since, DateTimeKind.Utc);  // set the timezone to UTC.
            GetTracksByMobileSinceResponse resp = service.GetTracksByMobileSince(req);
            if (resp != null)
            {
                GetTracksByMobileSinceResponseTracks trackscontainer = resp.Tracks;
                if (trackscontainer == null)
                    return null;
                return trackscontainer.Track;
            }
            return null;
        }

    }
}
